final int CELL_SIZE = 50;
final int CELL_X = 10;
final int CELL_Y = 10;
int[][] cell;
int[] stack_x, stack_y;
int stack_top;
boolean isFilling;
int key_flipflop;

void setup() {
  size(CELL_SIZE*CELL_X + 270, CELL_SIZE*CELL_Y);
  stack_x = new int[CELL_X * CELL_Y];
  stack_y = new int[CELL_X * CELL_Y];
  stack_top = 0;
  cell = new int[CELL_X][CELL_Y];
  for(int i=0; i<10; i++){
    cell[0][i] = 1;
    cell[9][i] = 1;
    cell[i][0] = 1;
    cell[i][9] = 1;
  }
  isFilling = false;
  key_flipflop = 0;
  textSize(18);
}

void mouseDragged() {
  if(mouseX < CELL_SIZE*CELL_X && mouseY < CELL_SIZE*CELL_Y && isFilling == false) {
    cell[mouseY/CELL_SIZE][mouseX/CELL_SIZE] = 1;
  }
}

void push(int x, int y) {
  stack_x[stack_top] = x;
  stack_y[stack_top] = y;
  stack_top++;
}

void drawCell() {
  for(int i=0; i<CELL_X; i++){
    for(int j=0; j<CELL_Y; j++){   
      if(cell[j][i] == 1) {  
        fill(0);
      }   
      stroke(128);
      rect(i*CELL_SIZE, j*CELL_SIZE, CELL_SIZE, CELL_SIZE);
      noFill();
    }
  }
}

void keyPressed() {
   key_flipflop = 1 -  key_flipflop;  
}

void showStack() {
  int s_top = stack_top;
  if(s_top >= 24) { s_top = 23; }
  fill(0);
  String s = "stack_top = ";
  s = s + Integer.toString(stack_top);
  text(s, CELL_SIZE*CELL_X + 10, 20); 
  
  for(int i=0; i<s_top; i++){
    String n = "stack_x[";
    n = n + Integer.toString(i);
    n = n + "] = ";
    n =  n + Integer.toString(stack_x[i]);
    if(i==s_top-1 && stack_top < 24) { fill(255, 0, 0); } 
    text(n, CELL_SIZE*CELL_X + 10, CELL_SIZE*CELL_Y - i*20 - 5);  
  }
  fill(0);

  for(int i=0; i<s_top; i++){
    String n = "stack_y[";
    n = n + Integer.toString(i);
    n = n + "] = ";
    n = n + Integer.toString(stack_y[i]);
    if(i==s_top-1 && stack_top < 24) { fill(255, 0, 0); } 
    text(n, CELL_SIZE*CELL_X + 140, CELL_SIZE*CELL_Y - i*20 - 5);  
  }
}

void showNum() {
  fill(255);
  for(int i=0; i<10; i++){
    String s = Integer.toString(i);
    text(s, i*CELL_SIZE + 20, 30);  
    text(s, 20, i*CELL_SIZE + 30);
  }  
  fill(0);
}

void showNextCell() {
  if(stack_top != 0) {
    fill(255, 0, 0);
    rect(stack_x[stack_top-1]*CELL_SIZE, stack_y[stack_top-1]*CELL_SIZE, CELL_SIZE, CELL_SIZE);
    fill(255, 0, 0, 128);
    rect(stack_x[stack_top-1]*CELL_SIZE, 0, CELL_SIZE, stack_y[stack_top-1]*CELL_SIZE+CELL_SIZE);
    rect(0, stack_y[stack_top-1]*CELL_SIZE, stack_x[stack_top-1]*CELL_SIZE+CELL_SIZE, CELL_SIZE);
    fill(0);
  }
}

void draw() {
  background(255, 255, 255);
  
  int x, y, c;
  drawCell();
  if (mousePressed && (mouseButton == RIGHT) && isFilling == false) {
    isFilling = true;
    if(mouseX < CELL_SIZE*CELL_X && mouseY < CELL_SIZE*CELL_Y) {
      push(mouseX/CELL_SIZE, mouseY/CELL_SIZE);
      key_flipflop = 1;
    }
  }
 
  if(isFilling == true &&  key_flipflop == 1){   
    if(stack_top != 0 ) { 
      stack_top--;    
      x = stack_x[stack_top];
      y = stack_y[stack_top];
      cell[y][x] = 1;
      
      c = cell[y-1][x];
      if(c != 1){ push(x, y-1); }  
      c = cell[y+1][x];
      if(c != 1){ push(x, y+1); }  
      c = cell[y][x-1];
      if(c != 1){ push(x-1, y); }
      c = cell[y][x+1];
      if(c != 1){ push(x+1, y); }
      
      key_flipflop = 0;
    } else {
      isFilling = false; 
    }
  }
  
  showStack();
  showNextCell();
  showNum();
}



